<?php
/*
  $Id: abxSales.php,v 1.25 2007/09/25 17:09:08 devosc Exp $

  AuctionBlox, sell more, work less!
  http://www.auctionblox.com

  Copyright (c) 2004 AuctionBlox
*/

  if (class_exists('abxManager') === false) {

    require_once(DIR_FS_ABX_CLASSES . 'abxManager.php');

  }

  if (class_exists('abxPage') === false) {

    require_once(DIR_FS_ABX_CLASSES . 'Page/abxPage.php');

  }

  class abxSales extends abxManager {

    function &getSales($filter = null)
    {
      global $abxDatabase, $languages_id;

      $auction_query_raw =
        "select DISTINCT SQL_CALC_FOUND_ROWS" .
        " a.auction_basket_id as id, " .
        " a.site, a.listing_type, a.quantity as qty," .
        " a.ext_id, a.ext_title, a.ext_desc," .
        " a.quantity, a.price_start, a.price_end," .
        " a.insurance, a.shipping, a.sales_tax as tax, " .
        " a.products_id, a.time_start, a.time_end, a.listing_status, a.currency, a.orders_id," .
        " a.payment_provider, a.payment_transaction_id, a.payment_amount, a.payment_fee, a.payment_currency, " .
        " l.profile_id," .
        " si.url," .
        " b.ext_email_address, b.ext_customer_id, b.customers_id," .
        " w.label as workflow_label, f.label as feedback_label," .
        " w.state_id as workflow_state_id, f.state_id as feedback_state_id " .
        " FROM " . TABLE_ABX_BASKET . " a" .
        " LEFT JOIN " . TABLE_ABX_LISTINGS . " l on (a.auction_house_id = l.auction_house_id and a.ext_id = l.ext_id)" .
        " LEFT JOIN " . TABLE_ABX_SITES . " si on (a.auction_house_id = si.auction_house_id and a.site = si.site)" .
        " LEFT JOIN " . TABLE_ABX_WINNERS . " b on (a.auction_winner_id = b.auction_winner_id)" .
        " LEFT JOIN " . TABLE_ABX_FEEDBACK_STATE . " f on (a.feedback_left = f.state_id)" .
        " LEFT JOIN " . TABLE_ABX_WORKFLOW_STATE . " w on (a.workflow_state = w.state_id)" .
        " WHERE w.language_id = $languages_id" .
        " AND f.language_id = $languages_id" .
        " AND a.archived = 0";
        
      if (empty($filter) === false) 
      {
        $auction_query_raw .= " AND a.listing_status = " . (int)$filter;
      }
      
      return $auction_query_raw;
    }

    function remove($auction_basket_id)
    {
      global $abxDatabase;

      return $abxDatabase->delete(TABLE_ABX_BASKET,"auction_basket_id in (" . implode(',',$auction_basket_id) . ")");
    }

    function sendInvoice(&$abxList)
    {
      global $messageStack;

      $uuids = $this->getAuctionSaleUuids($abxList);

      if (empty($uuids) === false) {

        $abxAPI = new abxAPI;

        $array = array(
          'defaultProfileId' => $_POST['defaultProfileId'],
          'uuids' => $uuids
        );

        $response = $abxAPI->call('email.sendWinningBidderEmail',$array);

        if ($response['code'] == 'success') {

          foreach($abxList as $id)
            $this->setNextWorkflowState($id,'INVOICE');

          $messageStack->add_session(SUCCESS_TEXT_SALE_INVOICES_SENT, 'success');

        } else {

          $messageStack->add_session(ERROR_TEXT_SALE_INVOICE_SEND_FAILED, 'error');

        }

      }
    }

    function sendReminder(&$abxList)
    {
      global $messageStack;

      $uuids = $this->getAuctionSaleUuids($abxList);

      if (empty($uuids) === false) {

        $abxAPI = new abxAPI;

        $array = array(
          'defaultProfileId' => $_POST['defaultProfileId'],
          'uuids' => $uuids
        );

        $response = $abxAPI->call('email.sendReminderEmail',$array);

        if ($response['code'] == 'success') {

          foreach($abxList as $id)
           $this->setNextWorkflowState($id,'REMINDER');

          $messageStack->add_session(SUCCESS_TEXT_SALE_REMINDERS_SENT, 'success');

        } else {

          $messageStack->add_session(ERROR_TEXT_SALE_REMINDER_SEND_FAILED, 'error');

        }

      }
    }

    function sendWarning(&$abxList)
    {
      global $messageStack;

      $uuids = $this->getAuctionSaleUuids($abxList);

      if (empty($uuids) === false) {

        $abxAPI = new abxAPI;

        $array = array(
          'defaultProfileId' => $_POST['defaultProfileId'],
          'uuids' => $uuids
        );

        $response = $abxAPI->call('email.sendWarningEmail',$array);

        if ($response['code'] == 'success') {
          foreach($abxList as $id)
            $this->setNextWorkflowState($id,'WARNING');

          $messageStack->add_session(SUCCESS_TEXT_SALE_WARNINGS_SENT, 'success');

        } else {

          $messageStack->add_session(ERROR_TEXT_SALE_WARNING_SEND_FAILED, 'error');

        }
      }
    }

    function getWorkflowState($currentState)
    {
      global $abxDatabase;

      $state = $abxDatabase->fetch_row("SELECT label FROM " . TABLE_ABX_WORKFLOW_STATE . " WHERE state_id = '" . addslashes($currentState) . "'");

      return @$state['label'];
    }

    function getNextWorkflowState($currentState)
    {
      global $abxDatabase;

      $state = $abxDatabase->fetch_row("SELECT next_state_id FROM " . TABLE_ABX_WORKFLOW_STATE . " WHERE state_id = '" . addslashes($currentState) . "'");

      return @$state['next_state_id'];
    }

    function setNextWorkflowState($oID, $currentState)
    {
      global $abxDatabase;

      $nextState = $this->getNextWorkflowState($currentState);

      $abxDatabase->update(TABLE_ABX_BASKET, array( 'workflow_state' => $nextState),'auction_basket_id = ' . (int)$oID);
    }

    function downloadSales($seller_id)
    {
      global $messageStack;

      $abxAPI = new abxAPI;

      $response = $abxAPI->callBySellerID('sale.downloadSales',$seller_id);

      if ($response['code'] == 'success')

        $messageStack->add_session(TEXT_REQUEST_SUCCESSFULL, 'success');

      else

        $messageStack->add_session(ERROR_TEXT_REQUEST_FAILED, 'error');
    }

    function archive($aArr, $sPaid, $sShipped, $nStatus) {
      global $abxDatabase;
      $abxDatabase->update(TABLE_ABX_BASKET, array( 'archived' => '1'), 'auction_basket_id in (' . implode(',', $aArr) . ')');
    }
    
    function getArchivedSalesPaginatorQuery() {
      global $languages_id;

      $sQuery =
        "select DISTINCT SQL_CALC_FOUND_ROWS" .
        " a.auction_basket_id as id," .
        " a.site, a.listing_type, a.ext_id, a.ext_title, a.ext_desc," .
        " a.quantity, a.price_start, a.price_end," .
        " a.insurance, a.shipping, a.sales_tax, a.products_id," .
        " a.time_start, a.time_end, a.listing_status,a.currency, a.orders_id," .
        " l.profile_id," .
        " si.url," .
        " b.ext_email_address, b.ext_customer_id, b.customers_id," .
        " w.label as workflow_label, f.label as feedback_label," .
        " w.state_id as workflow_state_id, f.state_id as feedback_state_id " .
        
		" FROM " . TABLE_ABX_BASKET . " a" .
        " LEFT JOIN " . TABLE_ABX_LISTINGS . " l on (a.auction_house_id = l.auction_house_id and a.ext_id = l.ext_id)" .
        " LEFT JOIN " . TABLE_ABX_SITES . " si on (a.auction_house_id = si.auction_house_id and a.site = si.site)" .
        " LEFT JOIN " . TABLE_ABX_WINNERS . " b on (a.auction_winner_id = b.auction_winner_id)" .
        " LEFT JOIN " . TABLE_ABX_FEEDBACK_STATE . " f on (a.feedback_left = f.state_id)" .
        " LEFT JOIN " . TABLE_ABX_WORKFLOW_STATE . " w on (a.workflow_state = w.state_id)" .
        		
        " WHERE w.language_id = $languages_id" .
        " AND f.language_id = $languages_id" .
        " AND a.archived = 1";

      return $sQuery;
    }

    function restoreArchived($aArr) {
      global $abxDatabase;

    	$aUpdate = array('archived' => 0);
    	$sWhere = 'auction_basket_id IN ('.implode(',', $aArr).')';
        $abxDatabase->update(TABLE_ABX_BASKET, $aUpdate, $sWhere);
    }

  }//end class
?>